$fn = 55;
bottom_gutter = 6.33;
drywall_screw_dia = 9/64 * 25.4 ; 
box_width = 59;
box_height = 27.5 + bottom_gutter;
plate_thickness = 1.25;
channel_depth = 40.0;

plate_mount_screw_dia = 10/64 * 25.4;
plate_mount_castle_dia = plate_mount_screw_dia * 1.9;

cable_diameter_dp = 18/64.0 * 25.4; 
cable_diameter_usb = 13/64.0 * 25.4; 
cable_diameter_cat5e = 14/64.0 * 25.4;
cable_diameter_ac = 20/64.0 * 25.4; 
cable_diameter_audio = 13/64.0 * 25.4; 

border_width = 12;

left_spacing = 4.0;
cable_spacing = 2.333;
wall_thickness = 2.0;

module rounded_rectangle(x,y,z,rounding_radius){
  minkowski(){
    translate([rounding_radius,rounding_radius,0]){
      cube([x - (rounding_radius*2),y - (rounding_radius*2),z]);
    }
    cylinder(r=rounding_radius, h=0.01);
  };
}
module plate_mount(){
  difference(){
    union(){    
      cylinder( r= plate_mount_castle_dia/2, h = 10.0);      
      translate([-1 * plate_mount_castle_dia, -1 * plate_mount_castle_dia/2, 0]){
        cube([plate_mount_castle_dia, plate_mount_castle_dia, 10.0]);
      }
    }
  translate([0,0,-3.0]){
        cylinder( r= plate_mount_screw_dia/2 * 0.975, h = 14.0);
      }
  }
}

module cable_holes(){
      union(){
      cylinder(r = cable_diameter_dp/2, h = 10.0);
      translate([cable_diameter_dp + cable_spacing, 0, 0]){
        cylinder(r = cable_diameter_dp/2, h= 10.0);
        
        translate([cable_diameter_dp/2 + cable_diameter_usb/2 + cable_spacing, 0, 0]){
          cylinder(r = cable_diameter_usb/2, h = 10.0); 
          
          translate([cable_diameter_usb/2 + cable_diameter_cat5e/2 +cable_spacing, 0, 0]){
            cylinder(r = cable_diameter_cat5e/2, h = 10.0);
            
            translate([cable_diameter_cat5e/2 + cable_diameter_ac/2  + cable_spacing, 0, 0]){
              cylinder(r = cable_diameter_ac/2, h = 10.0);
              translate([cable_diameter_ac/2 + cable_diameter_audio/2 + cable_spacing , 0, 0]) {
                cylinder( r= cable_diameter_audio/2, h =10.0);
              }
            }
          }
        }
      }
    }
  }



union(){
difference(){
  difference(){
    union(){
      //cube([box_width + (border_width * 2), box_height + (border_width *2), plate_thickness]);            
      rounded_rectangle(box_width + (border_width * 2), box_height + (border_width *2), plate_thickness, 8);
      translate([border_width, border_width, plate_thickness]){        
        difference(){
          cube([box_width, box_height,channel_depth]);
          union(){
            translate([wall_thickness, wall_thickness,-6]){
              cube([box_width - wall_thickness *2, box_height - wall_thickness *2, channel_depth + 9]);
            }
            
            translate([0,wall_thickness + 1,3]){
                translate([box_height * (2/3.0)/2, channel_depth/2, box_width/2]){
  rotate([-90,0,-90]){
    translate([box_height * (2/3.0)/-2, channel_depth/-2, box_width/-2]){
 linear_extrude(height = box_width*2) {
              polygon([
                [0,0],                
                [box_height * (2/3.0),0],
                [0,channel_depth]
              ]);
            }
          }
          }
        }
            }
                    
          }
        }
      }
    }
    union(){
    translate([border_width + wall_thickness, border_width + bottom_gutter, -3.0]){
      cube([box_width - wall_thickness *2, box_height - bottom_gutter - wall_thickness , plate_thickness + 3.1]); 
    }
    translate([border_width/2, border_width/2, -3.0]){
        cylinder(r=1.02 * drywall_screw_dia/2, h = 10.0);
    }
    translate([box_width + (border_width*1.5), border_width/2, -3.0]){
        cylinder(r=1.02 * drywall_screw_dia/2, h = 10.0);
    }
    translate([box_width + (border_width*1.5), box_height + (border_width*1.5), -3.0]){
        cylinder(r=1.02 * drywall_screw_dia/2, h = 10.0);
    }
    translate([border_width/2, box_height + (border_width*1.5), -3.0]){
        cylinder(r=1.02 * drywall_screw_dia/2, h = 10.0);
    }
    }
  }
  
  translate([border_width + left_spacing +3, bottom_gutter + border_width, -3.0]){
cable_holes();
    
  }
}

union(){
  translate([border_width + plate_mount_castle_dia, border_width + box_height/2 ,0]){

    plate_mount();
  }

 translate([box_width + border_width - plate_mount_castle_dia, border_width + box_height/2 ,0]){
  rotate([0,0,180]){
    plate_mount();
  }
  }

}
}

color([0.1,0.88,0.1]){
difference(){
translate([border_width * 0.7222,border_width * 0.7222,-2]){
  difference(){
    translate([0,0, 0]){
      difference(){
        rounded_rectangle(box_width + (border_width/1.8), box_height + (border_width/1.8) , plate_thickness, 4);
        translate([border_width/3.6,bottom_gutter * -0.5,-3.0]){
          rounded_rectangle(box_width, bottom_gutter*2, plate_thickness + 4.0,2);
        }
        
      }
    }
    
    translate([border_width/3.6 + left_spacing + 3,bottom_gutter + border_width/3.6,-3.0]){
      cable_holes();
    }
    
    
  }
}
union(){
 translate([border_width + plate_mount_castle_dia, border_width + box_height/2 ,-3]){
        cylinder(r= plate_mount_screw_dia/2*1.2, h = 10.0);        
      }
 translate([box_width + border_width - plate_mount_castle_dia, border_width + box_height/2 ,-3]){
         cylinder(r= plate_mount_screw_dia/2 * 1.2, h = 10.0);        
  } 
      
}
}
}
